#include "Vacuometro.h"
#include <avr/interrupt.h>
#if defined(ARDUINO) && ARDUINO >= 100
	#include "Arduino.h"
#else
	#include "WProgram.h"
#endif

// Constructors ////////////////////////////////////////////////////////////////
Vacuometro_Class::Vacuometro_Class()
{
}
// Public Methods //////////////////////////////////////////////////////////////
void Vacuometro_Class::Init()
{
    Vacu_step = 0;
    Media = 1;
    Alpha = 0.5;
    Serial.begin(38400);
   // Serial.begin(115200);

}

void Vacuometro_Class::End()
{
    Serial.end();
}
void Vacuometro_Class::SparaDati(void)
{   Serial.write("$");
    Serial.write("$");
    Serial.write("$");
    Serial.write("$");

    for(int i=0;i<4;i++)
    {
      Serial.write(ASend.byte[i]);
    }
    for(int i=0;i<4;i++)
    {
      Serial.write(BSend.byte[i]);
    }
    for(int i=0;i<4;i++)
    {
      Serial.write(CSend.byte[i]);
    }
    for(int i=0;i<4;i++)
    {
      Serial.write(DSend.byte[i]);
    }

    for(int i=0;i<4;i++)
    {
      Serial.write(TSend.byte[i]);
    }
}

void Vacuometro_Class::SendDati(float* A, float* B, float* C, float* D, float* T)
{
    ASend.value = *A;
    BSend.value = *B;
    CSend.value = *C;
    DSend.value = *D;
    TSend.value = *T;
}

uint8_t Vacuometro_Class::Read()
{
  static uint8_t Err = 0;
  uint8_t data;
  uint8_t numc = Serial.available();  //dio merda
  if(numc > 0)
  {
    for (uint8_t i=0; i < numc; i++)
    {	
      data = Serial.read();
	  restart:
      switch(Vacu_step)//parte da zero
      {		 
    case 0:
          if(data == 0x40)// sincronizzo il primo carattere
          {
              Vacu_step++;
          }
          if(data == 0x24)
          {
              Vacu_step = 3;
          }
          break;

    case 1:
          if(data == 0x40)
          {
              Vacu_step++;
              break;
          }
else{
          Vacu_step = 0;
          goto restart;
}
    case 2:
          Vacu_step = 0;
           for(int i=0;i<4;i++)
           {
             Serial.write(ASend.byte[i]);
           }
           for(int i=0;i<4;i++)
           {
             Serial.write(BSend.byte[i]);
           }
           for(int i=0;i<4;i++)
           {
             Serial.write(CSend.byte[i]);
           }
           for(int i=0;i<4;i++)
           {
             Serial.write(DSend.byte[i]);
           }

           for(int i=0;i<4;i++)
           {
             Serial.write(TSend.byte[i]);
           }
          break;

     case 3:
          if(data == 0x24)
                    {
                        Vacu_step++;
                        Vacu_payload_counter = 0;
                        //Serial.print("OK");
                    }
          else
          {
            Vacu_step = 0;
            goto restart;
          }
          break;
      case 4:
          Vacu_buffer[Vacu_payload_counter++] = data;
          if (Vacu_payload_counter == 8)
             {Vacu_step++;}
             break;
      case 5:
          Vacu_step = 0;
          Media = Bytes2Float(&Vacu_buffer[0]);
          Alpha = Bytes2Float(&Vacu_buffer[4]);
      Err = 0;

      break;

      }
    }
  }
  return Err;//0 = OK
}

/****************************************************************
 * 
 ****************************************************************/

int32_t Vacuometro_Class::Bytes2Long(unsigned char Buffer[])
{
    longUnion.byte[3] = *(Buffer);
    longUnion.byte[2] = *(Buffer+1);
    longUnion.byte[1] = *(Buffer+2);
    longUnion.byte[0] = *(Buffer+3);
	return(longUnion.dword);
}

float Vacuometro_Class::Bytes2Float(unsigned char Buffer[])
{
    floatUnion.byte[0] = *(Buffer);
    floatUnion.byte[1] = *(Buffer+1);
    floatUnion.byte[2] = *(Buffer+2);
    floatUnion.byte[3] = *(Buffer+3);
    return(floatUnion.value);
}
Vacuometro_Class VAC;
